# frozen_string_literal: true

require 'zip'
require 'interactor'
require 'interactor/contracts'
require 'prelands_rails/concerns/hash'
require 'prelands_rails/concerns/base'
require 'prelands_rails/concerns/can_handle_errors'
require 'prelands_rails/concerns/abstract_interactor'
require 'prelands_rails/concerns/my_aws_client'

require 'prelands_rails/create_simple_source/detect_incoming_locales'
require 'prelands_rails/create_simple_source/check_zip_files/extract_files'
require 'prelands_rails/create_simple_source/check_zip_files/detect_absent_files'
require 'prelands_rails/create_simple_source/check_zip_files'
require 'prelands_rails/create_simple_source/validate_zip_content/validate_html/html'
require 'prelands_rails/create_simple_source/validate_zip_content/validate_html'
require 'prelands_rails/create_simple_source/validate_zip_content/validate_js/js'
require 'prelands_rails/create_simple_source/validate_zip_content/validate_css/css'
require 'prelands_rails/create_simple_source/validate_zip_content/validate_incoming_files/zip_archive'
require 'prelands_rails/create_simple_source/validate_zip_content/validate_js'
require 'prelands_rails/create_simple_source/validate_zip_content/validate_css'
require 'prelands_rails/create_simple_source/validate_zip_content/validate_incoming_files'
require 'prelands_rails/create_simple_source/validate_zip_content'
require 'prelands_rails/create_simple_source/compile/html_compiler'
require 'prelands_rails/create_simple_source/compile'
require 'prelands_rails/create_simple_source/upload/uploader'
require 'prelands_rails/create_simple_source/upload'
require 'prelands_rails/create_simple_source/create_record'
require 'prelands_rails/create_simple_source'

require 'prelands_rails/update_simple_source/upload/delete_compiled_files'
require 'prelands_rails/update_simple_source/check_zip_files'
require 'prelands_rails/update_simple_source/compile'
require 'prelands_rails/update_simple_source/update_record'
require 'prelands_rails/update_simple_source/upload'
require 'prelands_rails/update_simple_source/validate_zip_content'
require 'prelands_rails/update_simple_source'

require 'prelands_rails/validate_simple_source'

module PrelandsRails
end
